/*

 Gestione color 
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"

int SudoNotEvidence ()
{
	int y,x;
	CmdInfo *cella;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (SUD_BUF[y][x] & (1<<(EVIDENCE-1)))
			{
				sprintf (BUFF,"%d%d",y,x);
				cella=CercaNomeComando (BUFF);
				cella->Bg=GetColor(BUTTONBG);
				PrintFlush(cella);
			}
		}
	}
	return (0);
}
int EvidenziaCandidati(int Candidato)
{
	int x,y;
	CmdInfo *cella;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (SUD_BUF[y][x] & (1 << (Candidato-1)))
			{
				if (SUD_BUF[y][x])
				{
					sprintf (BUFF,"%d%d",y,x);
					cella=CercaNomeComando (BUFF);
					cella->Bg=EVIDENCE_BG;
					
					PrintFlush(cella);
				}
			}
		}
	}
	return (0);
}

int SudoEvidence ()
{
	static CmdInfo *oldcella=NULL;
	CmdInfo *cella=UltimoComandoSelezionato(0,NULL);
	int Candidato;
	
	Candidato=(cella->Label[0])-'0';

	if (Candidato==EVIDENCE) return 0;

	if (EVIDENCE)
	{
		oldcella->Bg=GetColor(BUTTONBG);
		oldcella->BUpDn=!oldcella->BUpDn;
		PrintFlush(oldcella);
		SudoNotEvidence ();
	}

	if (Candidato)
	{
		cella->Bg=LightColor(cella->Bg);
		cella->BUpDn=!cella->BUpDn;
		PrintFlush(cella);
		EvidenziaCandidati(Candidato);
	}
	

	oldcella=cella;
	EVIDENCE=Candidato;

	return (0);
}


int SudoListBoxCallBack (CmdInfo *cmd, int Type)
{
	// 
	// ListBox CallBack
	//
	static CmdInfo *cell[10];
	static unsigned int bg[10],fg[10];
	static int num_cell=0;
	int i,r,c;
	unsigned int newbg,newfg;
	char *p=(cmd)->Label;
	//
	if (Type==LeaveNotify)
	{
		for (i=0;i<num_cell;i++)
		{
				cell[i]->Bg=bg[i];
				cell[i]->Fg=fg[i];
			
				PrintFlush(cell[i]);
		}
		return (0);
		
	}
	if (Type==EnterNotify)
	{
		num_cell=0;
		i=0;r=0;c=0;

		newbg=GIALLO;
		newfg=NERO;

		if (!strncmp (p,"    Unset",9))
		{
			newbg=ROSSO;
			newfg=NERO;
		}
		if (!strncmp (p,"  Set",5))
		{
			newbg=VERDE;
			newfg=NERO;
		}

		while (p[i])
		{

			if (p[i]=='R') 	r=p[i+1]-'0';
			if (p[i]=='C') 	c=p[i+1]-'0';
			if (r && c)
			{
				r--;c--;
				//
				sprintf (BUFF,"%d%d",r,c);
				cell[num_cell]=CercaNomeComando (BUFF);
				if (cell[num_cell])
				{
					bg[num_cell]=cell[num_cell]->Bg;
					fg[num_cell]=cell[num_cell]->Fg;

					cell[num_cell]->Bg=newbg;
					cell[num_cell]->Fg=newfg;
			
					PrintFlush(cell[num_cell]);
					num_cell++;
				}
				r=0;c=0;
			}
			i++;
		}
	}
	/*
		// Cancella CorrenteItem
	if (ViewComment->CorrenteItem)
	{
		if ( (ViewComment->CorrenteItem)->Cmd )
		{
			((ViewComment->CorrenteItem)->Cmd)->Focus=0;
			((ViewComment->CorrenteItem)->Cmd)->Stato=0;
		
			PrintFlush(((ViewComment->CorrenteItem)->Cmd));
		}
	}
	*/
	//
	return (0);
}
